%define current_version 9.0.1
%define _debugsource_template %{nil}

Name:		prl-disk-tool
Summary:	Virtuozzo disk manipulation tool
Version:	%{current_version}
Release:        2%{?dist}
License:	GPLv2
Group:		Applications/System
Source:		%{name}-%{version}.tar.bz2
ExclusiveArch:	x86_64
Requires:	ploop >= 7.0.13
Requires:	libguestfs >= 1.40.2
Requires:	libguestfs-tools-c >= 1.40.2
Requires:	libguestfs-xfs >= 1.40.2
Requires:	libguestfs-appliance >= 1.40.2-5.1.vz7.2
#Requires:	btrfs-progs >= 4.2
Requires:	qemu-img >= 1.5.3

BuildRequires:	qt5-devel
BuildRequires:	qt5
BuildRequires:	boost-devel
BuildRequires:	boost-static
BuildRequires:	libguestfs-devel >= 1.40.2


%description
prl-disk-tool is an utility to manipulate virtual machine and Container
disk images. It performs image resizing, compacting etc. and supports
different filesystems (ext, ntfs, btrfs, xfs).

Virtuozzo is a powerful, easy to use, cost effective server virtualization
solution that empowers PC users with the ability to create completely
networked, fully portable, entirely independent virtual machines and Containers
on a single physical machine.

%prep
%setup -q

%build
qmake-qt5
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install INSTALL_ROOT=$RPM_BUILD_ROOT/

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%attr(755,root,root) %{_sbindir}/*
%{_mandir}/man8/prl_disk_tool.8*
%{_docdir}/%{name}-%{version}
%{_datadir}/%{name}/*

%changelog
* Mon Jan 10 2022 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 9.0.1
 - fixed build for qmake-qt5 (Aleksandr Leskin <aleksandr.leskin@virtuozzo.com>)
 - Bump version to 9.0.0 #PSBM-137397
 - Replace qt4 with qt5

* Wed May 19 2021 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 7.0.53
 - Use snapshot Tag instead of ID for operations in qemu-img #PSBM-128303

* Fri Apr 09 2021 Dmitry Mishin <dim@virtuozzo.com> 7.0.51
 - Fix snapshot list parsing #PSBM-127741 (Pavel Vokhmyanin
<pvokhmyanin@virtuozzo.com>)

* Tue Jan 26 2021 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 7.0.50
 - Make lvm_parser py3 ready #PSBM-100836

* Fri Jan 22 2021 Dmitry Mishin <dim@virtuozzo.com> 7.0.49
 - Fix build for vz8 #PSBM-100836 (Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com>)

* Thu Sep 03 2020 VZ Auto Builder <dsilakov@virtuozzo.com> 7.0.46
 - PSBM-106039 (Denis Silakov <dsilakov@virtuozzo.com>)

* Mon Sep 30 2019 Konstantin B. Bukharov <bkb@virtuozzo.com> 7.0.45
 - Rework GPT backup header regeneration #PSBM-85688 (Pavel Vokhmyanin
<pvokhmyanin@virtuozzo.com>)
 - Update Copyright (Igor Sukhih <igor@virtuozzo.com>)

* Thu Apr 18 2019 Konstantin B. Bukharov <bkb@virtuozzo.com> 7.0.44
 - Prevent overflow in getNeededSpace calculation ##PSBM-93339 (Pavel Vokhmyanin
<pvokhmyanin@virtuozzo.com>)

* Wed Jun 20 2018 Konstantin B. Bukharov <bkb@virtuozzo.com> 7.0.43
 - Cleanup unused VirtResize code #PSBM-85856 (Pavel Vokhmyanin
<pvokhmyanin@virtuozzo.com>)

* Thu Jun 14 2018 Konstantin B. Bukharov <bkb@virtuozzo.com> 7.0.42
 - Fix typo in constant name (Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com>)
 - Fix volume Group deactivation order on shrink #PSBM-85807 (Pavel Vokhmyanin
<pvokhmyanin@virtuozzo.com>)

* Thu Jun 07 2018 Konstantin B. Bukharov <bkb@virtuozzo.com> 7.0.41
 - Introduce in-place shrink #PSBM-71183 (Pavel Vokhmyanin
<pvokhmyanin@virtuozzo.com>)

* Fri Mar 23 2018 Igor Sukhih <igor@virtuozzo.com> 7.0.40
 - Retain cluster_size upon disk shrink #PSBM-82809 (Pavel Vokhmyanin
<pvokhmyanin@virtuozzo.com>)

* Mon Dec 18 2017 bkbbkb <bkb@virtuozzo.com> 7.0.39
 - Do not account btrfs subvolumes in compact info #PSBM-76088 (Pavel Vokhmyanin
<pvokhmyanin@virtuozzo.com>)

* Mon Oct 02 2017 bkbbkb <bkb@virtuozzo.com> 7.0.37
 - BUGFIX PSBM-73426 Failed to get "write" lock

* Sat Sep 23 2017 bkb <bkb@virtuozzo.com> 7.0.36
 - BUGFIX PSBM-72718 Failed to get write lock by 'qemu-img resize'

* Fri Apr 14 2017 Inga Pyass <ipyass@virtuozzo.com> 7.0.35
 - Set mbr id only if it is different from current one #PSBM-63000 (Pavel
Vokhmyanin <pvokhmyanin@virtuozzo.com>)
 - print warning if filesystem isn't supported (PSBM-52674) (Pavel Ganyushin
<pganyushin@virtuozzo.com>)

* Mon Mar 20 2017 Inga Pyass <ipyass@virtuozzo.com> 7.0.33
 - Do not use timeout for compact action #PSBM-59413 (Igor Sukhih
<igor@virtuozzo.com>)
 - Restore C++ style comments, we don't need that much copyright unification
across OpenVZ projects (Andrey Bondrov <abondrov@virtuozzo.com>)
 - Update copyrights ( #PSBM-58317 ) (Andrey Bondrov <abondrov@virtuozzo.com>)
 - References PSBM-59958 (Artem Pavlenko <apavlenko@virtuozzo.com>)
 - References PSBM-59958 (Artem Pavlenko <apavlenko@virtuozzo.com>)

* Thu Mar 16 2017 Inga Pyass <ipyass@virtuozzo.com> 7.0.32
 - Fixed res returned for resize with snapshot #PSBM-62362 (Yuriy Pudgorodskiy
<yur@virtuozzo.com>)

* Tue Mar 14 2017 Inga Pyass <ipyass@virtuozzo.com> 7.0.31
 - Add actions logging (#PSBM-60377)

* Mon Mar 06 2017 Konstantin Volkov <wolf@virtuozzo.com> 7.0.28
 - Added rebrand defines, see #PSBM-58317

* Thu Mar  2 2017 Konstantin Volkov <wolf@virtuozzo.com> - 7.0.27-2
- Drop docs and mans installation, see #PSBM-58317

* Tue Dec 20 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.27
 - bug #PSBM-55815 aka /usr/bin/virt-resize tool not responding. Terminate it
now (Sergey Galas <shrike@virtuozzo.com>)

* Wed Dec 14 2016 Konstantin Volkov <wolf@virtuozzo.com> - 7.0.26-2
- Rebuild in 7.3 environment

* Wed Oct 19 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.26
 - Implement compact --info for ploop, #PSBM-50611
 - Refactor, #PSBM-50611
 - Move human-readable-units parser to util, #PSBM-50611
 - Extract CompactData, #PSBM-50611

* Tue Sep 20 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.25
 - Fix space estimation for empty image expand, #PSBM-52385

* Wed Sep 14 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.24
 - Get ploop partition using ploop, #PSBM-51859

* Wed Jul 27 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.23
 - Fix extended partitions' signatures, #PSBM-50176

* Thu Jul 21 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.22
 - Release image before running virt-sparsify.
 - Release image before running commit.
 - Improve logging on handle open/close, #PSBM-49738
 - Close the handle on snapshot operations, #PSBM-49738

* Tue Jun 21 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.21
 - Fixes for coverity, #PSBM-28844
 - Removed mentions of expanding disks. References PSBM-44914. (Artem Pavlenko
<apavlenko@virtuozzo.com>)

* Wed May 25 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.20
 - Ignore FAT in virt-sparsify.

* Thu May 12 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.19
 - Add more memory to guestfs appliance, #PSBM-46915
 - Fix filesystem overhead, #PSBM-28150

* Thu Mar 03 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.18
 - Added timeout calculation for virt-resize, #PSBM-44807
 - Added timeout arg to run_prg, added default arg values, #PSBM-44807

* Fri Feb 12 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.17
 - Fallback to mount_ro + statvfs if NTFS is dirty for displaying minsize,
   \#PSBM-43646
 - Ask user to run CHKDSK on ntfs_minimum_size fail, #PSBM-43646

* Fri Feb 05 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.16
 - Clear sigmask and change PG for child processes, #PSBM-43820
 - Ask user to run chkdsk on ntfs resize fail, #PSBM-43486

* Sat Jan 30 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.15
 - [de]activate VGs while recreating partition during partition-aware shrink,
   \#PSBM-43662
 - Added check for the case when PV resize is not needed, #PSBM-43643

* Fri Jan 29 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.14
 - Added lvm_parser.py to makefile, #PSBM-42843
 - Make Partition::List cache shared.
 - Implemented compact -i for LVM, #PSBM-42862
 - Implemented resize for LVM, #PSBM-41046
 - Implemented resize --info for LVM, #PSBM-41046
 - Added lvm config parsing, #PSBM-41046
 - Added lvm_parser.py, #PSBM-42843

* Wed Jan 27 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.12
 - Rebased to libguestfs-1.32.1 and removed duplicated functionality,
   \#PSBM-43555
 - Resize disks without partition table, #PSBM-43123
 - Implemented resize --info for ploop, #PSBM-42355
 - Move ResizeData to Command.h, #PSBM-42355
 - Rebase to new libguestfs-1.32.1

* Wed Jan 20 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.11
 - Resize logical on partition-aware shrink, #PSBM-42678
 - Move VirtResize to header
 - Add cancellation checks (Dmitry Andreev <dandreev@virtuozzo.com>)
 - Enable signal handler and pass cancellation token to GuestFS::Map object.
(Dmitry Andreev <dandreev@virtuozzo.com>)
 - Add new classes for signal handler and cancellation token (Dmitry Andreev
<dandreev@virtuozzo.com>)
 - Move GuestFS::Wrapper map from ResizeHelper to separate class (Dmitry Andreev
<dandreev@virtuozzo.com>)
 - Remove unused gfsAction from Compact operation (Dmitry Andreev
<dandreev@virtuozzo.com>)
 - Move ResizeHelper to a new header file and eliminate resize helper double
creation. (Dmitry Andreev <dandreev@virtuozzo.com>)

* Wed Jan 20 2016 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.10
 - Add call for guestfs_part_expand_gpt, #PSBM-42222
 - Force resize2fs to display minimum size, #PSBM-42534
 - Drop convert command, #PSBM-42354

* Wed Dec 23 2015 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.9
 - Try to apply/remove snapshots only in case of failure, #PSBM-42438
 - Workaround for multiple ntfs resize attempt, #PSBM-42438
 - Fixed qemu-img snapshot -l output parsing, #PSBM-42071
 - Fix for forbidden ntfs mount in libguestfs, #PSBM-42438

* Mon Dec 21 2015 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.8
 - Perform FS shrink on overlay to preserve original image, #PSBM-42438
 - Added swap partition support for resize.
 - Fixed vm/ct disk path templates, #PSBM-42429
 - Forbid resize/convert snapshotted images, #PSBM-42071

* Tue Dec 15 2015 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.7
 - Save/restore GPT GUID for partitions.
 - Fallback to partition-unaware resize if last partition contains unknown FS,
#PSBM-42233
 - Move GPT backup header during partition-unaware expand, #PSBM-42222
 - Bugfix: invalid full backing filename calculation.
 - Implemented in-place resize --resize_partition (for expand only).
 - Preserving GPT GUID for partitions is supported in libguestfs >= 1.29.25

* Tue Dec 01 2015 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.6
 - Bugfix: comparison of sizes in mb and bytes.
 - Implemented shrink without resizing last partition, #PSBM-41616
 - Fix absent qemu-img commit -b, #PSBM-39075
 - Added lazy refcounts.
 - Fix resize estimates.
 - Added fake --comm parameter for compatibility.

* Fri Oct 30 2015 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.5
 - Changed convert --plain to manually call posix_fallocate().

* Wed Oct 28 2015 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.4
 - Fixed .pro to create symlink.

* Wed Oct 28 2015 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.3
 - Renamed binary to prl_disk_tool, added prl-disk-tool symlink. (Maxim
Perevedentsev <mperevedentsev@parallels.com>)
 - Fixed manual. (Maxim Perevedentsev <mperevedentsev@parallels.com>)
 - Changed binary and man name. (Maxim Perevedentsev
<mperevedentsev@parallels.com>)

* Tue Oct 27 2015 Maxim Perevedentsev <mperevedentsev@virtuozzo.com> 7.0.2
 - Added Makefile.version.
 - Added spec. (Maxim Perevedentsev <mperevedentsev@parallels.com>)

* Tue Oct 27 2015 Maxim Perevedentsev <mperevedentsev@parallels.com> 7.0.2
- Initial source code commit
